-- Copyright 2022 by Todd Hundersmarck (ThundR)
-- All Rights Reserved
THData = {} local THData_mt = Class(THData) local function runScript() end function THData:new(target, allowSelectUnitType, allowSelectUnit, initDataCallback, mt) mt = Utils.getNoNil(mt, THData_mt) local targetData = g_thMain:createDataTable(target, true) if g_thMain:argIsValid(targetData, "target", target) and g_thMain:argIsValid(type(mt) == "table", "mt", mt) then local newEnv = setmetatable(targetData, mt) if newEnv then newEnv.actionEventIds = {} newEnv.unitTypeList = {} newEnv.unitTypeMapping = {} newEnv.currentUnitType = 1 newEnv.currentUnitIndex = {} newEnv.lastUnitIndex = {} newEnv.maxNumUnits = {} if newEnv:initialize(allowSelectUnitType, allowSelectUnit, initDataCallback) then return newEnv end end end end function THData:initialize(allowSelectUnitType, allowSelectUnit, initDataCallback) if (not allowSelectUnitType or g_thMain:argIsValid(allowSelectUnitType == true, "allowSelectUnitType", allowSelectUnitType)) and (not allowSelectUnit or g_thMain:argIsValid(allowSelectUnit == true, "allowSelectUnit", allowSelectUnit)) and (initDataCallback == nil or g_thMain:argIsValid(type(initDataCallback) == "function", "initDataCallback", initDataCallback)) then table.insert(self.unitTypeList, g_thMain.UNIT_TYPE.VOLUME) table.insert(self.unitTypeList, g_thMain.UNIT_TYPE.WEIGHT) for i, unitTypeIdx in ipairs(self.unitTypeList) do self.unitTypeMapping[unitTypeIdx] = i end local unitSetList = g_thMain:getUnitSetList() for _, unitSetInfo in pairs(unitSetList) do local unitSetIdx = unitSetInfo.index self.currentUnitIndex[unitSetIdx] = {} self.lastUnitIndex[unitSetIdx] = {} self.maxNumUnits[unitSetIdx] = {} for _, unitTypeIdx in pairs(self.unitTypeList) do self.currentUnitIndex[unitSetIdx][unitTypeIdx] = 0 self.lastUnitIndex[unitSetIdx][unitTypeIdx] = 0 self.maxNumUnits[unitSetIdx][unitTypeIdx] = 0 end end self.allowSelectUnitType = Utils.getNoNil(allowSelectUnitType, true) self.allowSelectUnit = Utils.getNoNil(allowSelectUnit, true) if initDataCallback then self.initDataCallback = initDataCallback initDataCallback(self.target) end return true end return false end function THData:setUnitTypeChangedCallback(callback) if g_thMain:argIsValid(type(callback) == "function", "callback", callback) then self.unitTypeChangedCallback = callback end end function THData:setUnitChangedCallback(callback) if g_thMain:argIsValid(type(callback) == "function", "callback", callback) then self.unitChangedCallback = callback end end function THData:registerActionEvents() local actionEventIds = self.actionEventIds if self.allowSelectUnitType then local _, eventId = g_inputBinding:registerActionEvent(InputAction.UC_SELECT_UNIT_TYPE, self, self.actionSelectUnitType, false, true, false, true) g_inputBinding:setActionEventTextVisibility(eventId, false) actionEventIds.selectUnitType = eventId end if self.allowSelectUnit then local _, eventId = g_inputBinding:registerActionEvent(InputAction.UC_SELECT_UNIT, self, self.actionSelectUnit, false, true, false, true) g_inputBinding:setActionEventTextVisibility(eventId, false) actionEventIds.selectUnit = eventId end end function THData:unregisterActionEvents() local actionEventIds = self.actionEventIds if actionEventIds.selectUnitType then g_inputBinding:removeActionEvent(actionEventIds.selectUnitType) actionEventIds.selectUnitType = nil end if actionEventIds.selectUnit then g_inputBinding:removeActionEvent(actionEventIds.selectUnit) actionEventIds.selectUnit = nil end end function THData:actionSelectUnitType() if self.allowSelectUnitType then local newUnitType = self.currentUnitType + 1 if newUnitType > #self.unitTypeList then newUnitType = 1 end self.currentUnitType = newUnitType if self.unitTypeChangedCallback then self.unitTypeChangedCallback(self.target) end end end function THData:actionSelectUnit() if self.allowSelectUnit then local unitSetIdx = self:getCurrentUnitSet() local unitTypeIdx = self:getCurrentUnitType() local maxNumUnits = self.maxNumUnits[unitSetIdx][unitTypeIdx] local currentUnitIdx = self.currentUnitIndex[unitSetIdx][unitTypeIdx] local lastUnitIdx = self.lastUnitIndex[unitSetIdx][unitTypeIdx] if maxNumUnits > 0 then if currentUnitIdx > 0 then currentUnitIdx = currentUnitIdx + 1 else currentUnitIdx = lastUnitIdx + 1 end if currentUnitIdx > maxNumUnits then currentUnitIdx = 1 end self.currentUnitIndex[unitSetIdx][unitTypeIdx] = currentUnitIdx self.lastUnitIndex[unitSetIdx][unitTypeIdx] = currentUnitIdx if self.unitChangedCallback then self.unitChangedCallback(self.target) end end end end function THData:setMaxNumUnits(maxNumUnits, unitSet, unitType) if g_thMain:argIsValid(type(maxNumUnits) == "number", "maxNumUnits", maxNumUnits) then unitSet = Utils.getNoNil(unitSet, self:getCurrentUnitSet()) unitType = Utils.getNoNil(unitType, self:getCurrentUnitType()) local unitSetInfo = g_thMain:getUnitSet(unitSet, true) local unitTypeInfo = self:getUnitType(unitType, true) if unitSetInfo and unitTypeInfo then local unitSetIdx = unitSetInfo.index local unitTypeIdx = unitTypeInfo.index local currentUnitIdx = self.currentUnitIndex[unitSetIdx][unitTypeIdx] local lastUnitIdx = self.lastUnitIndex[unitSetIdx][unitTypeIdx] if maxNumUnits > 0 then if currentUnitIdx <= 0 then if lastUnitIdx > 0 then currentUnitIdx = math.min(lastUnitIdx, maxNumUnits) else currentUnitIdx = 1 end elseif currentUnitIdx > maxNumUnits then currentUnitIdx = maxNumUnits end else currentUnitIdx = 0 end self.maxNumUnits[unitSetIdx][unitTypeIdx] = maxNumUnits self.currentUnitIndex[unitSetIdx][unitTypeIdx] = currentUnitIdx if currentUnitIdx > 0 and currentUnitIdx ~= lastUnitIdx then self.lastUnitIndex[unitSetIdx][unitTypeIdx] = currentUnitIdx end return true end end return false end function THData:setMaxNumUnitsFromFillTypeList(list, listKey) if g_thMain:argIsValid(type(list) == "table", "list", list) and (listKey == nil or g_thMain:argIsValid(g_thMain:getIsType(listKey, "string|number"), "listKey", listKey)) then local unitSetIdx = self:getCurrentUnitSet() local unitTypeIdx = self:getCurrentUnitType() local maxNumUnits = 0 local isArray = listKey ~= nil local function setMaxUnits(pFillType) local vNumUnits = g_thMain:getFillTypeMaxNumUnits(pFillType, unitSetIdx, unitTypeIdx) maxNumUnits = math.max(maxNumUnits, vNumUnits) end if not isArray then for fillType, isValid in pairs(list) do if type(isValid) ~= "boolean" then maxNumUnits = 0 isArray = true break elseif isValid then setMaxUnits(fillType) end end end if isArray then for _, fillType in pairs(list) do if listKey then fillType = fillType[listKey] end setMaxUnits(fillType) end end if self:setMaxNumUnits(maxNumUnits, unitSetIdx, unitTypeIdx) then return maxNumUnits end end return 0 end function THData:getUnitType(unitType, verbose, raise) local unitTypeInfo = g_thMain:getUnitType(unitType, verbose, raise) if unitTypeInfo then if not self.unitTypeMapping[unitTypeInfo.index] then unitTypeInfo = nil end raise = Utils.getNoNil(raise, verbose) g_thMain:msgOnTrue(unitTypeInfo == nil and verbose, raise, THCore.MSG.ARGUMENT_INVALID, "unitType", unitType) return unitTypeInfo end end function THData:getCurrentUnitType(getInfo) if not getInfo or g_thMain:argIsValid(getInfo == true, "getInfo", getInfo) then local unitTypeIdx = self.unitTypeList[self.currentUnitType] local unitTypeInfo = self:getUnitType(unitTypeIdx, true) if unitTypeInfo and not getInfo then return unitTypeInfo.index end return unitTypeInfo end end function THData:getCurrentUnitSet(getInfo) return g_thMain:getCurrentUnitSet(getInfo) end function THData:getMaxNumUnits(unitSet, unitType) unitSet = Utils.getNoNil(unitSet, self:getCurrentUnitSet()) unitType = Utils.getNoNil(unitType, self:getCurrentUnitType()) local unitSetInfo = g_thMain:getUnitSet(unitSet, true) local unitTypeInfo = self:getUnitType(unitType, true) if unitSetInfo and unitTypeInfo then return self.maxNumUnits[unitSetInfo.index][unitTypeInfo.index] end return 0 end function THData:getFillTypeUnitData(fillType, unitSet, unitType, descIndex) unitSet = Utils.getNoNil(unitSet, g_thMain:getCurrentUnitSet()) unitType = Utils.getNoNil(unitType, self:getCurrentUnitType()) local unitSetInfo = g_thMain:getUnitSet(unitSet, true) local unitTypeInfo = self:getUnitType(unitType, true) if unitSetInfo and unitTypeInfo then local unitSetIdx = unitSetInfo.index local unitTypeIdx = unitTypeInfo.index descIndex = Utils.getNoNil(descIndex, self.currentUnitIndex[unitSetIdx][unitTypeIdx]) return g_thMain:getFillTypeUnitData(fillType, unitSetIdx, unitTypeIdx, descIndex) end end runScript()