-- Copyright 2022 by Todd Hundersmarck (ThundR)
-- All Rights Reserved
THMain = {} local THMain_mt = Class(THMain, THCore) local function runScript() g_thMain = THMain:new("thUnitConvert") if g_thMain then local globalEnv = g_thMain:getGlobalEnv() local modPath = g_thMain.modPath local dataKey = g_thMain.dataKey globalEnv.THUnitConvert = THMain globalEnv.g_thUnitConvert = g_thMain createFolder(g_thMain.settingsPath) g_xmlManager:addCreateSchemaFunction(function() THMain.xmlSchema = XMLSchema.new(dataKey) end) g_xmlManager:addInitSchemaFunction(function() THMain.initializeXMLSchema() end) local MessageType = globalEnv.MessageType MessageType.UC_UNITS_CHANGED = nextMessageTypeId() g_thMain:hookFunction("I18N", "formatNumber", THMain.I18N) g_thMain:hookFunction("I18N", "formatVolume", THMain.I18N) g_thMain:hookFunction("I18N", "formatMass", THMain.I18N) g_thMain:hookFunction("I18N", "formatMoney", THMain.I18N) g_thMain:hookFunction("FillTypeManager", "loadMapData", THMain.FillTypeManager) g_thMain:hookFunction("FillTypeManager", "addFillType", THMain.FillTypeManager) source(modPath.."scripts/Data.lua") source(modPath.."scripts/gui/hud/FillLevelsDisplay.lua") source(modPath.."scripts/gui/InGameMenuPricesFrame.lua") source(modPath.."scripts/gui/InGameMenuProductionFrame.lua") end end function THMain:new(dataKey, mt) mt = Utils.getNoNil(mt, THMain_mt) local newEnv = THCore:new(dataKey, mt) if newEnv then local modName = newEnv.modName local modPath = newEnv.modPath newEnv.addonModName = "FS22_TH_UnitConvertCompanion" newEnv.unitTypes = { byId = {}, byIndex = {}, idToIndex = {} } newEnv.UNIT_TYPE = newEnv.unitTypes.idToIndex table.insert(newEnv.unitTypes.byIndex, {name = "volume"}) table.insert(newEnv.unitTypes.byIndex, {name = "weight"}) for i, unitTypeInfo in ipairs(newEnv.unitTypes.byIndex) do unitTypeInfo.id = unitTypeInfo.name:upper() unitTypeInfo.index = i newEnv.unitTypes.byId[unitTypeInfo.id] = unitTypeInfo newEnv.unitTypes.idToIndex[unitTypeInfo.id] = unitTypeInfo.index end newEnv:initializeUnits() newEnv:addUnit("liter", 1, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("bushel", 0.028378, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("cubicMeter", 0.001, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("cubicFoot", 0.035315, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("cubicYard", 0.001308, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("gallon", 0.264172, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("fluidOunce", 33.814023, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("kilogram", 1, "weight", nil,nil,nil, modName, modPath, true) newEnv:addUnit("ounce", 35.27396, "weight", nil,nil,nil, modName, modPath, true) newEnv:addUnit("pound", 2.204623, "weight", nil,nil,nil, modName, modPath, true) newEnv:addUnit("hundredWeight", 0.022046, "weight", nil,nil,nil, modName, modPath, true) newEnv:addUnit("tonne", 0.001, "weight", nil,nil,nil, modName, modPath, true) newEnv:addUnit("ton", 0.0011023, "weight", nil,nil,nil, modName, modPath, true) newEnv:addUnit("animal", 1, "volume", nil,nil,nil, modName, modPath, true) newEnv:addUnit("piece", 1, "volume", nil,nil,nil, modName, modPath, true) newEnv:initializeUnitSets() newEnv:addUnitSet("imperial", nil, modName, modPath, true) newEnv:addUnitSet("metric", nil, modName, modPath, true) newEnv:initializeUnitTitleMapping() end return newEnv end function THMain:initializeModsToLoad() THMain:superClass().initializeModsToLoad(self) local addonModInfo = self:getLoadedMod(self.addonModName) if addonModInfo then table.insert(self.modsToLoad, addonModInfo) end end function THMain.initializeXMLSchema() local xmlSchema = THMain.xmlSchema local unitKey = "map.units.unit(?)" xmlSchema:register(XMLValueType.STRING, unitKey.."#name", "Name of unit") xmlSchema:register(XMLValueType.FLOAT, unitKey.."#factor", "Unit conversion factor") xmlSchema:register(XMLValueType.STRING, unitKey.."#type", "Unit type (i.e. volume, weight, etc.)") xmlSchema:register(XMLValueType.STRING, unitKey.."#title", "Unit long title") xmlSchema:register(XMLValueType.STRING, unitKey.."#titlePlural", "Unit plural title") xmlSchema:register(XMLValueType.STRING, unitKey.."#titleShort", "Unit abbreviated title") local unitSetKey = "map.unitSets" xmlSchema:register(XMLValueType.BOOL, unitSetKey.."#reset", "Reset existing unit sets", false) xmlSchema:register(XMLValueType.STRING, unitSetKey..".unitSet(?)#name", "Name of unit set") xmlSchema:register(XMLValueType.STRING, unitSetKey..".unitSet(?)#title", "Unit set title") local unitSetUnitsKey = unitSetKey..".unitSet(?).units" xmlSchema:register(XMLValueType.BOOL, unitSetUnitsKey.."#reset", "Reset existing default units", false) xmlSchema:register(XMLValueType.STRING, unitSetUnitsKey..".unit(?)#name", "Name of unit") xmlSchema:register(XMLValueType.INT, unitSetUnitsKey..".unit(?)#precision", "Decimal places to display") local fillTypeGroupKey = "map.fillTypeGroups.group(?)" xmlSchema:register(XMLValueType.STRING, fillTypeGroupKey.."#name", "Name of fillType group") xmlSchema:register(XMLValueType.STRING, fillTypeGroupKey.."#title", "FillType group title") local fillTypeKey = "map.fillTypes.fillType(?)" xmlSchema:register(XMLValueType.STRING, fillTypeKey.."#name", "Name of fillType") xmlSchema:register(XMLValueType.STRING, fillTypeKey.."#group", "Name of fillType group") local function registerFillTypeUnits(pBaseKey) local vUnitsKey = pBaseKey..".units" xmlSchema:register(XMLValueType.BOOL, vUnitsKey.."#reset", "Reset existing fillType units", false) xmlSchema:register(XMLValueType.STRING, vUnitsKey..".unitSet(?)#name", "Name of unit set") xmlSchema:register(XMLValueType.BOOL, vUnitsKey..".unitSet(?)#reset", "Reset existing unit set units", false) xmlSchema:register(XMLValueType.STRING, vUnitsKey..".unitSet(?).unit(?)#name", "Name of unit") xmlSchema:register(XMLValueType.INT, vUnitsKey..".unitSet(?).unit(?)#precision", "Decimal places to display") end registerFillTypeUnits(fillTypeGroupKey) registerFillTypeUnits(fillTypeKey) end function THMain:loadMapData(dataType) if self:argIsInvalid(type(dataType) == "string", "dataType", dataType) then return false end local userFilename = string.format("%s%s.xml", self.settingsPath, dataType) local loadFunc = self["load"..self:properCase(dataType).."FromXMLFile"] for _, loadedMod in ipairs(self.modsToLoad) do local loadedModName = Utils.getNoNil(loadedMod.modName, "") if loadedModName ~= "" then local loadedModFile = loadedMod.modFile local loadedModPath = loadedMod.modDir local dataFilename = "" local allowAppend = false if loadedModName == self.modName or loadedModName == self.mapModName or loadedModName == self.addonModName then allowAppend = true end local modXMLFile = loadXMLFile("UCModDesc", loadedModFile) if Utils.getNoNil(modXMLFile, 0) ~= 0 then dataFilename = getXMLString(modXMLFile, "modDesc.unitConvert."..dataType.."#filename") if dataFilename then dataFilename = Utils.getFilename(dataFilename, loadedModPath) end delete(modXMLFile) end if loadedModName == self.modName then if userFilename and not fileExists(userFilename) then copyFile(dataFilename, userFilename, true) end end local dataXMLFile = XMLFile.loadIfExists("UCModData", dataFilename, THMain.xmlSchema) if Utils.getNoNil(dataXMLFile, 0) ~= 0 then loadFunc(self, dataXMLFile, loadedModName, loadedModPath, allowAppend) dataXMLFile:delete() end end end if not self.isMultiplayer then if userFilename and fileExists(userFilename) then local userXMLFile = XMLFile.load("UCUserData", userFilename, THMain.xmlSchema) if Utils.getNoNil(userXMLFile, 0) ~= 0 then loadFunc(self, userXMLFile, nil,nil, true) userXMLFile:delete() end end end return true end function THMain:initializeUnits() self.units = { byId = {}, byIndex = {}, byType = {}, idToIndex = {} } self.UNIT = self.units.idToIndex for _, unitTypeIdx in pairs(self.UNIT_TYPE) do self.units.byType[unitTypeIdx] = {} end self.fillTypeUnits = {} self.fillTypeUnitMapping = {} end function THMain:initializeUnitSets() self.unitSets = { byId = {}, byIndex = {}, idToIndex = {} } self.UNIT_SET = self.unitSets.idToIndex end function THMain:initializeUnitTitleMapping() local titleMap = {} local literText = g_i18n:getText("unit_liter") local literShortText = g_i18n:getText("unit_literShort") local cubicText = g_i18n:getText("unit_cubic") local cubicShortText = g_i18n:getText("unit_cubicShort") local tonneShortText = g_i18n:getText("unit_tonsShort") local kilogramShortText = g_i18n:getText("unit_kg") local bushelText = g_i18n:getText("unit_bushels") local bushelShortText = g_i18n:getText("unit_bushelsShort") local piecesText = g_i18n:getText("unit_pieces") titleMap[literText] = {index = self.UNIT.LITER, isTitleShort = false, type = self.UNIT_TYPE.VOLUME} titleMap[literShortText] = {index = self.UNIT.LITER, isTitleShort = true, type = self.UNIT_TYPE.VOLUME} titleMap[cubicText] = {index = self.UNIT.CUBICMETER, isTitleShort = false, type = self.UNIT_TYPE.VOLUME} titleMap[cubicShortText] = {index = self.UNIT.CUBICMETER, isTitleShort = true, type = self.UNIT_TYPE.VOLUME} titleMap[tonneShortText] = {index = self.UNIT.TONNE, isTitleShort = true, type = self.UNIT_TYPE.WEIGHT} titleMap[kilogramShortText] = {index = self.UNIT.KILOGRAM, isTitleShort = true, type = self.UNIT_TYPE.WEIGHT} titleMap[bushelText] = {index = self.UNIT.BUSHEL, isTitleShort = false, type = self.UNIT_TYPE.VOLUME} titleMap[bushelShortText] = {index = self.UNIT.BUSHEL, isTitleShort = true, type = self.UNIT_TYPE.VOLUME} titleMap[piecesText] = {index = self.UNIT.PIECE, isTitleShort = false, type = self.UNIT_TYPE.VOLUME} self.unitTitleMapping = titleMap end function THMain:loadUnitsFromXMLFile(xmlFile, customEnv, baseDirectory, allowAppend) if self:argIsValid(type(xmlFile) == "table", "xmlFile", xmlFile) then local hasCustomEnv = Utils.getNoNil(customEnv, "") ~= "" xmlFile:iterate("map.units.unit", function(_, pKey) local vName = xmlFile:getValue(pKey.."#name") local vFactor = xmlFile:getValue(pKey.."#factor") local vUnitType = xmlFile:getValue(pKey.."#type") local vTitle = xmlFile:getValue(pKey.."#title") local vTitlePlural = xmlFile:getValue(pKey.."#titlePlural") local vTitleShort = xmlFile:getValue(pKey.."#titleShort") self:addUnit(vName, vFactor, vUnitType, vTitle, vTitlePlural, vTitleShort, customEnv, baseDirectory, allowAppend) end) local resetUnitSets = xmlFile:getValue("map.unitSets#reset", false) local unitSetsAreReset = false xmlFile:iterate("map.unitSets.unitSet", function(_, pUnitSetKey) local vUnitSetName = xmlFile:getValue(pUnitSetKey.."#name") local vUnitSetTitle = xmlFile:getValue(pUnitSetKey.."#title", vUnitSetName) local vUnitSetIsNew = false if allowAppend and not unitSetsAreReset and resetUnitSets then self:initializeUnitSets() unitSetsAreReset = true end if not self:getUnitSet(vUnitSetName) then vUnitSetIsNew = true end local vUnitSetInfo = self:addUnitSet(vUnitSetName, vUnitSetTitle, customEnv, baseDirectory, allowAppend) if vUnitSetInfo then local vResetUnits = xmlFile:getValue(pUnitSetKey..".units#reset", false) local vUnitsAreReset = false xmlFile:iterate(pUnitSetKey..".units.unit", function(_, pUnitKey) local vUnitName = xmlFile:getValue(pUnitKey.."#name") local vUnitPrecision = xmlFile:getValue(pUnitKey.."#precision", 0) if allowAppend and not vUnitsAreReset and vResetUnits then for _, vUnitTypeIdx in pairs(self.UNIT_TYPE) do vUnitSetInfo.units[vUnitTypeIdx] = {} vUnitSetInfo.unitMapping[vUnitTypeIdx] = {} end vUnitsAreReset = true end local vUnitInfo = self:getUnit(vUnitName) if vUnitInfo then local vUnitIsNew = hasCustomEnv and customEnv == vUnitInfo.customEnv if vUnitSetIsNew or vUnitIsNew or allowAppend then self:addDefaultUnit(vUnitSetInfo, vUnitInfo, vUnitPrecision, allowAppend) end end end) end end) if #self.unitSets.byIndex == 0 then self:warningMsg("No unit sets specified, adding default") self:addUnitSet("metric", nil, self.modName, self.modPath, true) end return true end return false end function THMain:addUnit(name, factor, unitType, title, titlePlural, titleShort, customEnv, baseDirectory, allowAppend) unitType = Utils.getNoNil(unitType, self.UNIT_TYPE.VOLUME) local unitTypeInfo = self:getUnitType(unitType, true) if unitTypeInfo and self:argIsValid(type(name) == "string" and name ~= "", "name", name) and (factor == nil or self:argIsValid(type(factor) == "number" and factor > 0 and factor < math.huge, "factor", factor)) and (title == nil or self:argIsValid(type(title) == "string", "title", title)) and (titlePlural == nil or self:argIsValid(type(titlePlural) == "string", "titlePlural", titlePlural)) and (titleShort == nil or self:argIsValid(type(titleShort) == "string", "titleShort", titleShort)) and (customEnv == nil or self:argIsValid(type(customEnv) == "string", "customEnv", customEnv)) and (baseDirectory == nil or self:argIsValid(type(baseDirectory) == "string", "baseDirectory", baseDirectory)) and (not allowAppend or self:argIsValid(allowAppend == true, "allowAppend", allowAppend)) then local unitInfo = self:getUnit(name) if not unitInfo then local unitTypeIdx = unitTypeInfo.index if not title and g_i18n:hasText("ucUnit_"..name, customEnv) then title = g_i18n:getText("ucUnit_"..name, customEnv) end if not titlePlural and g_i18n:hasText("ucUnit_"..name.."Plural", customEnv) then titlePlural = g_i18n:getText("ucUnit_"..name.."Plural", customEnv) end if not titleShort and g_i18n:hasText("ucUnit_"..name.."Short", customEnv) then titleShort = g_i18n:getText("ucUnit_"..name.."Short", customEnv) end title = Utils.getNoNil(title, name) titlePlural = Utils.getNoNil(titlePlural, title) titleShort = Utils.getNoNil(titleShort, "") unitInfo = { id = name:upper(), name = name, index = #self.units.byIndex + 1, factor = Utils.getNoNil(factor, 1), type = unitTypeIdx, title = g_i18n:convertText(title, customEnv), titlePlural = g_i18n:convertText(titlePlural, customEnv), titleShort = g_i18n:convertText(titleShort, customEnv), customEnv = customEnv } self.units.byId[unitInfo.id] = unitInfo self.units.byIndex[unitInfo.index] = unitInfo self.units.idToIndex[unitInfo.id] = unitInfo.index table.insert(self.units.byType[unitTypeIdx], unitInfo) if self:getIsFillTypeUnitType(unitTypeIdx) then table.insert(self.fillTypeUnits, unitInfo) self.fillTypeUnitMapping[unitInfo.index] = #self.fillTypeUnits end else if allowAppend then unitInfo.factor = Utils.getNoNil(factor, unitInfo.factor) if title then unitInfo.title = g_i18n:convertText(title, customEnv) end if titlePlural then unitInfo.titlePlural = g_i18n:convertText(titlePlural, customEnv) end if titleShort then unitInfo.titleShort = g_i18n:convertText(titleShort, customEnv) end end end return unitInfo end end function THMain:addUnitSet(name, title, customEnv, baseDirectory, allowAppend) if self:argIsValid(type(name) == "string" and name ~= "", "name", name) and (title == nil or self:argIsValid(type(title) == "string" and title ~= "", "title", title)) and (customEnv == nil or self:argIsValid(type(customEnv) == "string", "customEnv", customEnv)) and (baseDirectory == nil or self:argIsValid(type(baseDirectory) == "string", "baseDirectory", baseDirectory)) and (not allowAppend or self:argIsValid(allowAppend == true, "allowAppend", allowAppend)) then local unitSetInfo = self:getUnitSet(name) if not unitSetInfo then if customEnv == self.modName then if not title and g_i18n:hasText("ucUnitSet_"..name, customEnv) then title = g_i18n:getText("ucUnitSet_"..name, customEnv) end unitSetInfo = { id = name:upper(), name = name, index = #self.unitSets.byIndex + 1, title = g_i18n:convertText(title, customEnv), customEnv = customEnv, units = {}, unitMapping = {}, } for _, unitTypeIdx in pairs(self.UNIT_TYPE) do unitSetInfo.units[unitTypeIdx] = {} unitSetInfo.unitMapping[unitTypeIdx] = {} end self.unitSets.byIndex[unitSetInfo.index] = unitSetInfo self.unitSets.byId[unitSetInfo.id] = unitSetInfo self.unitSets.idToIndex[unitSetInfo.id] = unitSetInfo.index end elseif allowAppend then if title then unitSetInfo.title = g_i18n:convertText(title, customEnv) end end return unitSetInfo end end function THMain:addDefaultUnit(unitSet, unit, precision, allowAppend) local unitSetInfo = self:getUnitSet(unitSet) if unitSetInfo and (precision == nil or self:argIsValid(type(precision) == "number" and precision >= 0, "precision", precision)) and (not allowAppend or self:argIsValid(allowAppend == true, "allowAppend", allowAppend)) then local unitInfo = self:getUnit(unit) if unitInfo then local unitTypeIdx = unitInfo.type local unitData = unitSetInfo.units[unitTypeIdx] local unitMapping = unitSetInfo.unitMapping[unitTypeIdx] local unitDescIdx = unitMapping[unitInfo.index] local unitDesc = unitData[unitDescIdx] precision = Utils.getNoNil(precision, 0) if unitDesc then if allowAppend then unitDesc.info = unitInfo unitDesc.precision = math.floor(precision) end else unitDesc = { info = unitInfo, precision = math.floor(precision) } table.insert(unitData, unitDesc) unitMapping[unitInfo.index] = #unitData end return true end end return false end function THMain:getUnit(unit, verbose, raise) if not verbose or self:argIsValid(verbose == true, "verbose", verbose) then local valType = type(unit) local unitInfo = nil if valType == "table" then unitInfo = self.units.byId[unit.id] if unitInfo ~= unit then unitInfo = nil end elseif valType == "string" then unitInfo = self.units.byId[unit:upper()] elseif valType == "number" then unitInfo = self.units.byIndex[unit] elseif unit ~= nil then verbose = true end raise = Utils.getNoNil(raise, verbose) self:msgOnTrue(unitInfo == nil and verbose, raise, THCore.MSG.ARGUMENT_INVALID, "unit", unit) return unitInfo end end function THMain:getUnitList() return self.units.byIndex end function THMain:getUnitsByType(unitType) local unitTypeInfo = self:getUnitType(unitType, true) if unitTypeInfo then return self.units.byType[unitTypeInfo.index] end end function THMain:getUnitSet(unitSet, verbose, raise) if not verbose or self:argIsValid(verbose == true, "verbose", verbose) then local valType = type(unitSet) local unitSetInfo = nil if valType == "table" then unitSetInfo = self.unitSets.byId[unitSet.id] if unitSetInfo ~= unitSet then unitSetInfo = nil end elseif valType == "string" then unitSetInfo = self.unitSets.byId[unitSet:upper()] elseif valType == "number" then unitSetInfo = self.unitSets.byIndex[unitSet] elseif unitSet ~= nil then verbose = true end raise = Utils.getNoNil(raise, verbose) self:msgOnTrue(unitSetInfo == nil and verbose, raise, THCore.MSG.ARGUMENT_INVALID, "unitSet", unitSet) return unitSetInfo end end function THMain:getUnitSetList() return self.unitSets.byIndex end function THMain:getCurrentUnitSet(getInfo) if not getInfo or self:argIsValid(getInfo == true, "getInfo", getInfo) then local useMiles = g_gameSettings:getValue(GameSettings.SETTING.USE_MILES) local unitSet = self.UNIT_SET.METRIC if useMiles then unitSet = self.UNIT_SET.IMPERIAL end if getInfo then return self:getUnitSet(unitSet, true) end return unitSet end end function THMain:getUnitType(unitType, verbose, raise) if not verbose or self:argIsValid(verbose == true, "verbose", verbose) then local valType = type(unitType) local unitTypeInfo = nil if valType == "table" then unitTypeInfo = self.unitTypes.byId[unitType.id] if unitTypeInfo ~= unitType then unitTypeInfo = nil end elseif valType == "string" then unitTypeInfo = self.unitTypes.byId[unitType:upper()] elseif valType == "number" then unitTypeInfo = self.unitTypes.byIndex[unitType] elseif unitType ~= nil then verbose = true end raise = Utils.getNoNil(raise, verbose) self:msgOnTrue(unitTypeInfo == nil and verbose, raise, THCore.MSG.ARGUMENT_INVALID, "unitType", unitType) return unitTypeInfo end end function THMain:getUnitTypeList() return self.unitTypes.byIndex end function THMain:initializeFillTypes() if not self.fillTypeManager then local managerData, manager = self:createDataTable(g_fillTypeManager) local modName = self.modName local modPath = self.modPath self.fillTypeManager = manager managerData.fillTypeGroups = { byId = {}, byIndex = {}, idToIndex = {} } managerData.FILLTYPE_GROUP = managerData.fillTypeGroups.idToIndex self:addFillTypeGroup("grain", nil, modName, modPath, true) self:addFillTypeGroup("solid", nil, modName, modPath, true) self:addFillTypeGroup("liquid", nil, modName, modPath, true) self:addFillTypeGroup("piece", nil, modName, modPath, true) self:addFillTypeGroup("animal", nil, modName, modPath, true) self:addFillTypeGroup("solidProduct", nil, modName, modPath, true) self:addFillTypeGroup("liquidProduct", nil, modName, modPath, true) local fillTypeList = manager:getFillTypes() for _, fillTypeInfo in pairs(fillTypeList) do local fillTypeData = self:getDataTable(fillTypeInfo) local categoryList, numCategories = self:getFillTypeCategories(fillTypeInfo.index, true) local fillTypeId = Utils.getNoNil(fillTypeInfo.name, "") fillTypeId = string.upper(fillTypeId) fillTypeData.isProduct = false if categoryList.COMBINE or fillTypeId == "SEEDS" or string.find(fillTypeId, "^SEED_") then fillTypeData.group = managerData.FILLTYPE_GROUP.GRAIN elseif categoryList.SPRAYER or categoryList.SLURRYTANK or categoryList.LIQUID then fillTypeData.group = managerData.FILLTYPE_GROUP.LIQUID elseif categoryList.ANIMAL then fillTypeData.group = managerData.FILLTYPE_GROUP.ANIMAL elseif categoryList.PIECE then fillTypeData.group = managerData.FILLTYPE_GROUP.PIECE elseif categoryList.PRODUCT then fillTypeData.isProduct = true if string.find(fillTypeId, "_OIL$") or fillTypeId == "GRAPEJUICE" then fillTypeData.group = managerData.FILLTYPE_GROUP.LIQUIDPRODUCT else fillTypeData.group = managerData.FILLTYPE_GROUP.SOLIDPRODUCT end else fillTypeData.group = managerData.FILLTYPE_GROUP.SOLID end fillTypeData.categories = categoryList fillTypeData.numCategories = numCategories fillTypeData.units = {} fillTypeData.unitMapping = {} fillTypeData.defaultUnitShort = fillTypeInfo.unitShort for _, unitSetIdx in pairs(self.UNIT_SET) do fillTypeData.units[unitSetIdx] = {} fillTypeData.unitMapping[unitSetIdx] = {} for _, unitTypeIdx in pairs(self.UNIT_TYPE) do if self:getIsFillTypeUnitType(unitTypeIdx) then fillTypeData.units[unitSetIdx][unitTypeIdx] = {} fillTypeData.unitMapping[unitSetIdx][unitTypeIdx] = {} end end end end end end function THMain:finalizeFillTypes() local fillTypeGroupList = self:getFillTypeGroupList() local unitSetList = self:getUnitSetList() local unitTypeList = self:getUnitTypeList() for _, groupInfo in pairs(fillTypeGroupList) do for _, unitSetInfo in pairs(unitSetList) do for _, unitTypeInfo in pairs(unitTypeList) do if self:getIsFillTypeUnitType(unitTypeInfo) then local unitList = groupInfo.units[unitSetInfo.index][unitTypeInfo.index] if #unitList == 0 then self:warningMsg("Group %q has no %s %s units associated with it, adding default", groupInfo.name, unitSetInfo.name, unitTypeInfo.name) if unitTypeInfo.id == "VOLUME" then if unitSetInfo.id == "IMPERIAL" then self:addFillTypeUnit(groupInfo, unitSetInfo, self.UNIT.CUBICFOOT, 1, true) else self:addFillTypeUnit(groupInfo, unitSetInfo, self.UNIT.LITER, 0, true) end elseif unitTypeInfo.id == "WEIGHT" then if unitSetInfo.id == "IMPERIAL" then self:addFillTypeUnit(groupInfo, unitSetInfo, self.UNIT.TON, 1, true) else self:addFillTypeUnit(groupInfo, unitSetInfo, self.UNIT.TONNE, 1, true) end end end end end end end end function THMain:loadFillTypesFromXMLFile(xmlFile, customEnv, baseDirectory, allowAppend) if self:argIsValid(type(xmlFile) == "table", "xmlFile", xmlFile) and (not allowAppend or self:argIsValid(allowAppend == true, "allowAppend", allowAppend)) then local hasCustomEnv = Utils.getNoNil(customEnv, "") ~= "" local function loadUnitData(pBaseKey, pTarget, pTargetIsNew) local vUnitsKey = pBaseKey..".units" local vResetUnits = xmlFile:getValue(vUnitsKey.."#reset", false) local vUnitsAreReset = false xmlFile:iterate(pBaseKey..".units.unitSet", function(_, pUnitSetKey) local vUnitSetName = xmlFile:getValue(pUnitSetKey.."#name") local vResetUnitSetUnits = xmlFile:getValue(pUnitSetKey.."#reset", false) local vUnitSetUnitsAreReset = false if allowAppend and not vUnitsAreReset and vResetUnits then for _, vUnitSetIdx in pairs(self.UNIT_SET) do pTarget.units[vUnitSetIdx] = {} pTarget.unitMapping[vUnitSetIdx] = {} for _, vUnitTypeIdx in pairs(self.UNIT_TYPE) do if self:getIsFillTypeUnitType(vUnitTypeIdx) then pTarget.units[vUnitSetIdx][vUnitTypeIdx] = {} pTarget.unitMapping[vUnitSetIdx][vUnitTypeIdx] = {} end end end vUnitsAreReset = true end local vUnitSetInfo = self:getUnitSet(vUnitSetName) if vUnitSetInfo then local vUnitSetIdx = vUnitSetInfo.index local vUnitSetIsNew = hasCustomEnv and customEnv == vUnitSetInfo.customEnv xmlFile:iterate(pUnitSetKey..".unit", function(_, pUnitKey) local vUnitName = xmlFile:getValue(pUnitKey.."#name") local vPrecision = xmlFile:getValue(pUnitKey.."#precision") if allowAppend and not vUnitsAreReset and not vUnitSetUnitsAreReset and vResetUnitSetUnits then for _, vUnitTypeIdx in pairs(self.UNIT_TYPE) do if self:getIsFillTypeUnitType(vUnitTypeIdx) then pTarget.units[vUnitSetIdx][vUnitTypeIdx] = {} pTarget.unitMapping[vUnitSetIdx][vUnitTypeIdx] = {} end end vUnitSetUnitsAreReset = true end local vUnitInfo = self:getFillTypeUnit(vUnitName) if vUnitInfo then local vUnitIsNew = hasCustomEnv and customEnv == vUnitInfo.customEnv if vUnitIsNew or vUnitSetIsNew or pTargetIsNew or allowAppend then self:addFillTypeUnit(pTarget, vUnitSetIdx, vUnitName, vPrecision, allowAppend) end end end) end end) end xmlFile:iterate("map.fillTypeGroups.group", function(_, pGroupKey) local vName = xmlFile:getValue(pGroupKey.."#name") local vTitle = xmlFile:getValue(pGroupKey.."#title") local vGroupIsNew = false if not self:getFillTypeGroup(vName) then vGroupIsNew = true end local vGroupInfo = self:addFillTypeGroup(vName, vTitle, customEnv, baseDirectory, allowAppend) if vGroupInfo then loadUnitData(pGroupKey, vGroupInfo, vGroupIsNew) end end) xmlFile:iterate("map.fillTypes.fillType", function(_, pFillTypeKey) local vName = xmlFile:getValue(pFillTypeKey.."#name") local vGroup = xmlFile:getValue(pFillTypeKey.."#group") local vFillTypeInfo = self:getFillType(vName) local vFillTypeData = self:getDataTable(vFillTypeInfo) if vFillTypeData then local vFillTypeIsNew = false if hasCustomEnv and customEnv == vFillTypeData.customEnv then vFillTypeIsNew = true end local vGroupInfo = self:getFillTypeGroup(vGroup) if vGroupInfo then local vGroupIsNew = hasCustomEnv and customEnv == vGroupInfo.customEnv if vFillTypeIsNew or vGroupIsNew or allowAppend then vFillTypeData.group = vGroupInfo.index end end loadUnitData(pFillTypeKey, vFillTypeData, vFillTypeIsNew) end end) return true end return false end function THMain:addFillTypeGroup(name, title, customEnv, baseDirectory, allowAppend) if self:argIsValid(type(name) == "string" and name ~= "", "name", name) and (title == nil or self:argIsValid(type(title) == "string" and title ~= "", "title", title)) and (customEnv == nil or self:argIsValid(type(customEnv) == "string", "customEnv", customEnv)) and (baseDirectory == nil or self:argIsValid(type(baseDirectory) == "string", "baseDirectory", baseDirectory)) and (not allowAppend or self:argIsValid(allowAppend == true, "allowAppend", allowAppend)) then local managerData = self:getDataTable(self.fillTypeManager) local groupInfo = self:getFillTypeGroup(name) if not groupInfo then if not title and g_i18n:hasText("ucFillTypeGroup_"..name, customEnv) then title = g_i18n:getText("ucFillTypeGroup_"..name, customEnv) end title = Utils.getNoNil(title, name) groupInfo = { id = name:upper(), name = name, index = #managerData.fillTypeGroups.byIndex + 1, title = g_i18n:convertText(title, customEnv), customEnv = customEnv, units = {}, unitMapping = {} } managerData.fillTypeGroups.byId[groupInfo.id] = groupInfo managerData.fillTypeGroups.byIndex[groupInfo.index] = groupInfo managerData.fillTypeGroups.idToIndex[groupInfo.id] = groupInfo.index for _, unitSetIdx in pairs(self.UNIT_SET) do groupInfo.units[unitSetIdx] = {} groupInfo.unitMapping[unitSetIdx] = {} for _, unitTypeIdx in pairs(self.UNIT_TYPE) do if self:getIsFillTypeUnitType(unitTypeIdx) then local unitData, unitMapping = self:getDefaultFillTypeUnits(unitSetIdx, unitTypeIdx, groupInfo.index) groupInfo.units[unitSetIdx][unitTypeIdx] = unitData groupInfo.unitMapping[unitSetIdx][unitTypeIdx] = unitMapping end end end else if allowAppend then if title then groupInfo.title = g_i18n:convertText(title, customEnv) end end end return groupInfo end end function THMain:addFillTypeUnit(target, unitSet, unit, precision, allowAppend) local unitSetInfo = self:getUnitSet(unitSet, true, false) if unitSetInfo and self:argIsValid(type(target) == "table", "target", target) and (precision == nil or self:argIsValid(type(precision) == "number" and precision >= 0, "precision", precision)) and (not allowAppend or self:argIsValid(allowAppend == true, "allowAppend", allowAppend)) then local unitInfo = self:getFillTypeUnit(unit, true, false) if unitInfo then local unitSetIdx = unitSetInfo.index local unitTypeIdx = unitInfo.type local unitData = target.units[unitSetIdx][unitTypeIdx] local unitMapping = target.unitMapping[unitSetIdx][unitTypeIdx] local unitDescIdx = unitMapping[unitInfo.index] local unitDesc = unitData[unitDescIdx] precision = Utils.getNoNil(precision, 0) if unitDesc then if allowAppend then unitDesc.info = unitInfo unitDesc.precision = math.floor(precision) end else unitDesc = { info = unitInfo, precision = math.floor(precision) } table.insert(unitData, unitDesc) unitMapping[unitInfo.index] = #unitData end return true end end return false end function THMain:getFillType(fillType, verbose, raise) if not verbose or self:argIsValid(verbose == true, "verbose", verbose) then local manager = self.fillTypeManager local valType = type(fillType) local fillTypeInfo = nil if valType == "table" then fillTypeInfo = manager:getFillTypeByName(fillType.name) if fillTypeInfo ~= fillType then fillTypeInfo = nil end elseif valType == "string" then fillTypeInfo = manager:getFillTypeByName(fillType) elseif valType == "number" then fillTypeInfo = manager:getFillTypeByIndex(fillType) elseif fillType ~= nil then verbose = true end raise = Utils.getNoNil(raise, verbose) self:msgOnTrue(fillTypeInfo == nil and verbose, raise, THCore.MSG.ARGUMENT_INVALID, "fillType", fillType) return fillTypeInfo end end function THMain:getFillTypeGroup(group, verbose, raise) if not verbose or self:argIsValid(verbose == true, "verbose", verbose) then local managerData = self:getDataTable(self.fillTypeManager) local groupInfo = nil local valType = type(group) if valType == "table" then groupInfo = managerData.fillTypeGroups.byId[group.id] if groupInfo ~= group then groupInfo = nil end elseif valType == "string" then groupInfo = managerData.fillTypeGroups.byId[group:upper()] elseif valType == "number" then groupInfo = managerData.fillTypeGroups.byIndex[group] elseif group ~= nil then verbose = true end raise = Utils.getNoNil(raise, verbose) self:msgOnTrue(groupInfo == nil and verbose, raise, THCore.MSG.ARGUMENT_INVALID, "group", group) return groupInfo end end function THMain:getFillTypeGroupList() local managerData = self:getDataTable(self.fillTypeManager) if managerData then return managerData.fillTypeGroups.byIndex end return {} end function THMain:getFillTypeCategories(fillType, create) local categoryList = {} local numCategories = 0 local manager = self.fillTypeManager local fillTypeInfo = self:getFillType(fillType, true) if fillTypeInfo then if not create then local fillTypeData = self:getDataTable(fillTypeInfo) if fillTypeData and fillTypeData.categories then return fillTypeData.categories, fillTypeData.numCategories end elseif self:argIsValid(create == true, "create", create) then for categoryName, fillTypeList in pairs(manager.categoryNameToFillTypes) do local categoryId = categoryName:upper() if fillTypeList[fillTypeInfo.index] then categoryList[categoryId] = true numCategories = numCategories + 1 end end end end return categoryList, numCategories end function THMain:getUnitFromUnitTitle(title) if title == nil then return end if self:argIsValid(type(title) == "string", "title", title) then return self.unitTitleMapping[title] end end function THMain:getFillTypeUnit(unit, verbose, raise) local unitInfo = self:getUnit(unit, verbose, raise) if unitInfo then if not self.fillTypeUnitMapping[unitInfo.index] then unitInfo = nil end raise = Utils.getNoNil(raise, verbose) self:msgOnTrue(unitInfo == nil and verbose, raise, THCore.MSG.ARGUMENT_INVALID, "unit", unit) return unitInfo end end function THMain:getDefaultFillTypeUnits(unitSet, unitType, group) local groupInfo, groupId = nil,nil if group then groupInfo = self:getFillTypeGroup(group, true) groupId = groupInfo.id end local unitSetInfo = self:getUnitSet(unitSet, true) local unitTypeInfo = self:getUnitType(unitType, true) local unitData = {} local unitMapping = {} local function setUnitData(pUnit, pPrecision) local vUnitInfo = self:getFillTypeUnit(pUnit, true) if vUnitInfo then if self:assert(unitMapping[vUnitInfo.index] == nil, 3, "Unit %q already assigned to %s unit set", vUnitInfo.name, unitSetInfo.name) then local vUnitDesc = { info = vUnitInfo, precision = pPrecision } table.insert(unitData, vUnitDesc) unitMapping[vUnitInfo.index] = #unitData end end end if unitSetInfo and unitTypeInfo then local unitSetId = unitSetInfo.id local unitTypeId = unitTypeInfo.id local isUnitTypeValid = self:getIsFillTypeUnitType(unitTypeId) if self:assert(isUnitTypeValid, nil, "Invalid fillType unit type %q", unitTypeInfo.name) then local defaultUnitList = unitSetInfo.units[unitTypeInfo.index] if #defaultUnitList > 0 then for _, unitDesc in ipairs(defaultUnitList) do local unitInfo = unitDesc.info if not unitMapping[unitInfo.index] then setUnitData(unitInfo.index, unitDesc.precision) end end else if unitSetId == "IMPERIAL" then if unitTypeId == "VOLUME" then if groupId == "ANIMAL" or groupId == "PIECE" then setUnitData(groupId, 0) elseif groupId == "SOLIDPRODUCT" then setUnitData(self.UNIT.PIECE, 1) elseif groupId == "LIQUIDPRODUCT" then setUnitData(self.UNIT.GALLON, 1) setUnitData(self.UNIT.FLUIDOUNCE, 0) else if groupId == "GRAIN" then setUnitData(self.UNIT.BUSHEL, 1) elseif groupId == "LIQUID" then setUnitData(self.UNIT.GALLON, 1) end setUnitData(self.UNIT.CUBICYARD, 1) setUnitData(self.UNIT.CUBICFOOT, 1) end elseif unitTypeId == "WEIGHT" then setUnitData(self.UNIT.TON, 1) setUnitData(self.UNIT.POUND, 0) if groupId == "SOLIDPRODUCT" or groupId == "LIQUIDPRODUCT" then setUnitData(self.UNIT.OUNCE, 0) end end else if unitTypeId == "VOLUME" then if groupId == "ANIMAL" or groupId == "PIECE" then setUnitData(groupId, 0) else setUnitData(self.UNIT.LITER, 0) end elseif unitTypeId == "WEIGHT" then setUnitData(self.UNIT.TONNE, 1) setUnitData(self.UNIT.KILOGRAM, 0) end end end end end return unitData, unitMapping end function THMain:getIsFillTypeUnitType(unitType) local unitTypeInfo = self:getUnitType(unitType, true) if unitTypeInfo then if unitTypeInfo.id == "VOLUME" or unitTypeInfo.id == "WEIGHT" then return true end end return false end function THMain:getFillTypeMaxNumUnits(fillType, unitSet, unitType) unitSet = Utils.getNoNil(unitSet, self:getCurrentUnitSet()) local fillTypeInfo = self:getFillType(fillType, true) local fillTypeData = self:getDataTable(fillTypeInfo) if fillTypeData then local unitSetInfo = self:getUnitSet(unitSet, true) local unitTypeInfo = self:getUnitType(unitType, true) if unitSetInfo and unitTypeInfo then local unitSetIdx = unitSetInfo.index local unitTypeIdx = unitTypeInfo.index local maxNumUnits = #fillTypeData.units[unitSetIdx][unitTypeIdx] if maxNumUnits == 0 then local groupInfo = self:getFillTypeGroup(fillTypeData.group, true) if groupInfo then maxNumUnits = #groupInfo.units[unitSetIdx][unitTypeIdx] end end return maxNumUnits end end return 0 end function THMain:getFillTypeMaxNumUnitsFromList(list, listKey, unitSet, unitType) if self:argIsValid(type(list) == "table", "list", list) and (listKey == nil or self:argIsValid(type(listKey) == "string" or type(listKey) == "number", "listKey", listKey)) then local maxNumUnits = 0 local isArray = listKey ~= nil local function setMaxUnits(pFillType) local vNumUnits = self:getFillTypeMaxNumUnits(pFillType, unitSet, unitType) maxNumUnits = math.max(maxNumUnits, vNumUnits) end if not isArray then for fillType, isValid in pairs(list) do if type(isValid) ~= "boolean" then maxNumUnits = 0 isArray = true break elseif isValid then setMaxUnits(fillType) end end end if isArray then for _, fillType in pairs(list) do if listKey then fillType = fillType[listKey] end setMaxUnits(fillType) end end return maxNumUnits end return 0 end function THMain:getFillTypeUnitData(fillType, unitSet, unitType, descIndex) unitSet = Utils.getNoNil(unitSet, self:getCurrentUnitSet()) local fillTypeInfo = self:getFillType(fillType, true) local unitSetInfo = self:getUnitSet(unitSet, true) local unitTypeInfo = self:getUnitType(unitType, true) if fillTypeInfo and unitSetInfo and unitTypeInfo and self:argIsValid(type(descIndex) == "number" and descIndex > 0, "descIndex", descIndex) then local unitSetIdx = unitSetInfo.index local unitTypeIdx = unitTypeInfo.index if self:getIsFillTypeUnitType(unitTypeIdx) then local massPerLiter = Utils.getNoNil(fillTypeInfo.massPerLiter, 0) local fillTypeData = self:getDataTable(fillTypeInfo) local unitData = fillTypeData.units[unitSetIdx][unitTypeIdx] if #unitData == 0 then local groupInfo = self:getFillTypeGroup(fillTypeData.group, true) unitData = groupInfo.units[unitSetIdx][unitTypeIdx] end descIndex = math.min(descIndex, #unitData) local unitDesc = unitData[descIndex] local unitInfo = unitDesc.info local factor = unitInfo.factor local precision = unitDesc.precision if unitInfo.type == self.UNIT_TYPE.WEIGHT then factor = factor * massPerLiter * 1000 end return unitInfo, factor, precision else self:errorMsg(nil, THCore.MSG.ARGUMENT_INVALID, "unitType", unitType) end end end THMain.I18N = {} function THMain.I18N:hook_formatNumber(superFunc, value, precision, forcePrecision, ...) local retText, ra,rb,rc,rd,re = superFunc(self, value, precision, forcePrecision, ...) local function appendFunc() if retText and Utils.getNoNil(precision, 0) > 0 and forcePrecision then local decimalSeparator = self.decimalSeparator local stringFindKey = ".+["..decimalSeparator.."](%d+)" local _, _, decimalText = string.find(retText, stringFindKey) if decimalText then local textLen = decimalText:len() if precision > textLen then retText = retText..string.rep("0", precision - textLen) end elseif precision > 0 then retText = retText..decimalSeparator..string.rep("0", precision) end end end g_thMain:pcall(appendFunc) return retText, ra,rb,rc,rd,re end function THMain.I18N:hook_formatVolume(superFunc, value, precision, unit, arg1, arg2, target, fillType) local function prependFunc() if target or fillType then local targetData = g_thMain:getDataTable(target) if g_thMain:argIsValid(targetData, "target", target) then unit = Utils.getNoNil(unit, self:getVolumeUnit()) local valUnitDesc = g_thMain:getUnitFromUnitTitle(unit) local isTitleShort = true if valUnitDesc then isTitleShort = valUnitDesc.isTitleShort end local unitInfo, factor, newPrecision = targetData:getFillTypeUnitData(fillType) if unitInfo then value = value * factor precision = newPrecision if isTitleShort then unit = unitInfo.titleShort elseif precision == 0 and math.floor(value) == 1 then unit = unitInfo.title else unit = unitInfo.titlePlural end end end end end g_thMain:pcall(prependFunc) return superFunc(self, value, precision, unit, arg1, arg2) end function THMain.I18N:hook_formatMass(superFunc, value, maxValue, showKg, arg1, arg2, target, fillType) local targetData, fillTypeInfo = nil,nil local _, formatNumberFunc, formatNumberOrigFunc = nil,nil,nil local _, getTextFunc, getTextOrigFunc = nil,nil,nil local function prependFunc() if target or fillType then targetData = g_thMain:getDataTable(target) fillTypeInfo = g_thMain:getFillType(fillType, true) if fillTypeInfo and g_thMain:argIsValid(targetData, "target", target) then _, formatNumberFunc, formatNumberOrigFunc = g_thMain:call("getFunctionData", self, "formatNumber") _, getTextFunc, getTextOrigFunc = g_thMain:call("getFunctionData", self, "getText") if formatNumberFunc and getTextFunc then local unitInfo, factor, precision = targetData:getFillTypeUnitData(fillType) if unitInfo then local massPerLiter = Utils.getNoNil(fillTypeInfo.massPerLiter, 0) if massPerLiter == 0 then value = 0 if maxValue then maxValue = 0 end else value = (value / massPerLiter) * factor if maxValue then maxValue = (maxValue / massPerLiter) * factor end end self.formatNumber = function(pSelf, pValue, pPrecision, ...) pPrecision = precision return formatNumberFunc(pSelf, pValue, pPrecision, ...) end self.getText = function(pSelf, pName, ...) if type(pName) == "string" and string.find(pName, "^unit_") then return unitInfo.titleShort end return getTextFunc(pSelf, pName, ...) end showKg = false end end end end end g_thMain:pcall(prependFunc) local ra,rb,rc,rd,re = superFunc(self, value, maxValue, showKg, arg1, arg2) if formatNumberFunc then self.formatNumber = formatNumberOrigFunc end if getTextFunc then self.getText = getTextOrigFunc end return ra,rb,rc,rd,re end function THMain.I18N:hook_formatMoney(superFunc, value, precision, addCurrency, currencySymbol, ...) local _, formatNumberFunc, formatNumberOrigFunc = g_thMain:call("getFunctionData", self, "formatNumber") if formatNumberFunc then self.formatNumber = function (pSelf, pValue, pPrecision, pForcePrecision, ...) if Utils.getNoNil(pPrecision, 0) > 0 then pForcePrecision = true end return formatNumberFunc(pSelf, pValue, pPrecision, pForcePrecision, ...) end end local ra,rb,rc,rd,re = superFunc(self, value, precision, addCurrency, currencySymbol, ...) if formatNumberFunc then self.formatNumber = formatNumberOrigFunc end return ra,rb,rc,rd,re end THMain.FillTypeManager = {} function THMain.FillTypeManager:hook_loadMapData(superFunc, xmlFile, missionInfo, baseDirectory, ...) local ra,rb,rc,rd,re = superFunc(self, xmlFile, missionInfo, baseDirectory, ...) local function appendFunc() g_thMain:loadMapData("units") g_thMain:initializeFillTypes() g_thMain:loadMapData("fillTypes") g_thMain:finalizeFillTypes() end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end function THMain.FillTypeManager:hook_addFillType(superFunc, name, title, showOnPriceTable, pricePerLiter, massPerLiter, maxPhysicalSurfaceAngle, hudOverlayFilename, baseDirectory, customEnv, ...) local fillTypeIsNew = true local function prependFunc() if type(name) == "string" then if self.nameToFillType[name:upper()] then fillTypeIsNew = false end end end g_thMain:pcall(prependFunc) local fillTypeInfo, ra,rb,rc,rd,re = superFunc(self, name, title, showOnPriceTable, pricePerLiter, massPerLiter, maxPhysicalSurfaceAngle, hudOverlayFilename, baseDirectory, customEnv, ...) local function appendFunc() if fillTypeInfo then local fillTypeData = g_thMain:getDataTable(fillTypeInfo, true) if fillTypeIsNew and Utils.getNoNil(customEnv, "") ~= "" then fillTypeData.customEnv = customEnv end end end g_thMain:pcall(appendFunc) return fillTypeInfo, ra,rb,rc,rd,re end runScript()