-- Copyright 2022 by Todd Hundersmarck (ThundR)
-- All Rights Reserved
THFillLevelsDisplay = {} local function runScript() g_thMain:hookFunction("FillLevelsDisplay", "new", THFillLevelsDisplay, nil, false) g_thMain:hookFunction("FillLevelsDisplay", "setVehicle", THFillLevelsDisplay) g_thMain:hookFunction("FillLevelsDisplay", "addFillLevel", THFillLevelsDisplay) g_thMain:hookFunction("FillLevelsDisplay", "updateFillLevelBuffers", THFillLevelsDisplay) g_thMain:hookFunction("FillLevelsDisplay", "updateFillLevelFrames", THFillLevelsDisplay) g_thMain:hookFunction("FillLevelsDisplay", "storeScaledValues", THFillLevelsDisplay) g_thMain:hookFunction("FillLevelsDisplay", "draw", THFillLevelsDisplay) end function THFillLevelsDisplay.hook_new(superFunc, hudAtlasPath, ...) local newEnv, ra,rb,rc,rd,re = superFunc(hudAtlasPath, ...) if newEnv then local function appendFunc() local displayData = THData:new(newEnv) displayData.fillTypeInfo = {} displayData.fillTypeTextSize = 0 displayData.validFillTypes = {} end g_thMain:pcall(appendFunc) end return newEnv, ra,rb,rc,rd,re end function THFillLevelsDisplay:hook_setVehicle(superFunc, vehicle, ...) local displayData = g_thMain:call("getDataTable", self) local ra,rb,rc,rd,re = superFunc(self, vehicle, ...) local function appendFunc() if displayData then if self.vehicle then displayData:registerActionEvents() else displayData:unregisterActionEvents() end end end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end function THFillLevelsDisplay:hook_addFillLevel(superFunc, fillType, fillLevel, capacity, ...) local displayData = g_thMain:call("getDataTable", self) local ra,rb,rc,rd,re = superFunc(self, fillType, fillLevel, capacity, ...) local function appendFunc() if displayData then if Utils.getNoNil(fillType, FillType.UNKNOWN) ~= FillType.UNKNOWN then local fillLevelBuffer = self.fillLevelBuffer if #fillLevelBuffer > 0 then for i = 1, #fillLevelBuffer do local bufferInfo = fillLevelBuffer[i] if bufferInfo.fillType == fillType and (bufferInfo.fillLevel > 0 or bufferInfo.capacity > 0) then displayData.validFillTypes[fillType] = true break end end end end end end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end function THFillLevelsDisplay:hook_updateFillLevelBuffers(superFunc, ...) local displayData = g_thMain:call("getDataTable", self) local function prependFunc() if displayData then g_thMain:clearTable(displayData.validFillTypes) end end local prependSuccess = g_thMain:pcall(prependFunc) local ra,rb,rc,rd,re = superFunc(self, ...) local function appendFunc() if displayData and prependSuccess then local fillLevelBuffer = self.fillLevelBuffer local maxNumUnits = displayData:setMaxNumUnitsFromFillTypeList(displayData.validFillTypes) if #fillLevelBuffer > 0 and maxNumUnits > 0 then for i = 1, #fillLevelBuffer do local bufferInfo = fillLevelBuffer[i] local fillTypeInfo = g_thMain:getFillType(bufferInfo.fillType) if fillTypeInfo and fillTypeInfo.index ~= FillType.UNKNOWN then local fillLevel = bufferInfo.fillLevel local capacity = bufferInfo.capacity if fillLevel and g_thMain:getUnitFromUnitTitle(fillTypeInfo.unitShort) then local unitInfo, factor, precision = displayData:getFillTypeUnitData(fillTypeInfo) if unitInfo then bufferInfo.fillLevel = fillLevel * factor bufferInfo.precision = precision if capacity and capacity > 0 and capacity < math.huge then bufferInfo.capacity = capacity * factor end local displayFillTypeInfo = displayData.fillTypeInfo[fillTypeInfo.index] if not displayFillTypeInfo then displayFillTypeInfo = g_thMain:createOverlayTable(fillTypeInfo) displayData.fillTypeInfo[fillTypeInfo.index] = displayFillTypeInfo end displayFillTypeInfo("setValue", "unitShort", " "..unitInfo.titleShort) displayFillTypeInfo("setValue", "unit", unitInfo) end end end end displayData:setMaxNumUnitsFromFillTypeList(displayData.validFillTypes) end end end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end function THFillLevelsDisplay:hook_updateFillLevelFrames(superFunc, ...) local displayData = g_thMain:call("getDataTable", self) local fillTypeManager, getFillTypeByIndexFunc, getFillTypeByIndexOrigFunc = nil,nil,nil local function prependFunc() if displayData and displayData:getMaxNumUnits() > 0 then fillTypeManager, getFillTypeByIndexFunc, getFillTypeByIndexOrigFunc = g_thMain:getFunctionData("g_fillTypeManager", "getFillTypeByIndex") if getFillTypeByIndexFunc then fillTypeManager.getFillTypeByIndex = function(pSelf, pFillType, ...) local vFillTypeInfo, vra,vrb,vrc,vrd,vre = getFillTypeByIndexFunc(pSelf, pFillType, ...) local function vAppendFunc() if vFillTypeInfo and vFillTypeInfo.index ~= FillType.UNKNOWN then local vDisplayFillTypeInfo = displayData.fillTypeInfo[vFillTypeInfo.index] vFillTypeInfo = Utils.getNoNil(vDisplayFillTypeInfo, vFillTypeInfo) end end g_thMain:pcall(vAppendFunc) return vFillTypeInfo, vra,vrb,vrc,vrd,vre end end end end g_thMain:pcall(prependFunc) local ra,rb,rc,rd,re = superFunc(self, ...) if getFillTypeByIndexFunc then fillTypeManager.getFillTypeByIndex = getFillTypeByIndexOrigFunc end return ra,rb,rc,rd,re end function THFillLevelsDisplay:hook_storeScaledValues(superFunc, ...) local displayData = g_thMain:call("getDataTable", self) local ra,rb,rc,rd,re = superFunc(self, ...) local function appendFunc() if displayData then local defaultTextSize = HUDElement.TEXT_SIZE.DEFAULT_TEXT local fillTypeTextSize = defaultTextSize - 3 local fillLevelTextSize = defaultTextSize - 1 local fillTypeTextPosX, fillTypeTextPosY = g_thMain:unpack(FillLevelsDisplay.POSITION.FILL_TYPE_TEXT) local fillTypeTextPos = {fillTypeTextPosX, fillTypeTextPosY - 9} local fillLevelTextPosX, fillLevelTextPosY = g_thMain:unpack(FillLevelsDisplay.POSITION.FILL_LEVEL_TEXT) local fillLevelTextPos = {fillLevelTextPosX, fillLevelTextPosY - 2} displayData.fillTypeTextSize = self:scalePixelToScreenHeight(fillTypeTextSize) self.fillLevelTextSize = self:scalePixelToScreenHeight(fillLevelTextSize) self.fillTypeTextOffsetX, self.fillTypeTextOffsetY = self:scalePixelToScreenVector(fillTypeTextPos) self.fillLevelTextOffsetX, self.fillLevelTextOffsetY = self:scalePixelToScreenVector(fillLevelTextPos) end end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end function THFillLevelsDisplay:hook_draw(superFunc, ...) local displayData = g_thMain:call("getDataTable", self) local ra,rb,rc,rd,re = superFunc(self, ...) local function appendFunc() if displayData and self:getVisible() then local baseX, baseY = self:getPosition() local width = self:getWidth() for i = 1, #self.fillLevelTextBuffer do local fillTypeText = self.fillTypeTextBuffer[i] if fillTypeText then local posX = baseX + width + self.fillTypeTextOffsetX local posY = baseY + (i - 1) * (self.frameHeight + self.frameOffsetY) if i == 1 then posX = posX + self.firstFillTypeOffset end setTextColor(g_thMain:unpack(FillLevelsDisplay.COLOR.FILL_LEVEL_TEXT)) setTextBold(false) setTextAlignment(RenderText.ALIGN_RIGHT) renderText(posX, posY + self.fillTypeTextOffsetY, displayData.fillTypeTextSize, fillTypeText) end end end end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end runScript()